;EasyCodeName=Module1,1
.686 ; create 32 bit code
.Model flat, StdCall  ;32 bit memory model
Option CaseMap :none  ; case sensitive

;The MASM32 Runtime Library include file.
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Include	\masm32\include\masm32rt.inc
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

.Code

start:
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	Call Main
	inkey        ; pause the screen while waiting for user to press any key
	             ; to continue
    exit
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

Main Proc
	Local WantContinue:DWord
	; Want Continue is the sentinel value of the while loop
    ;---------------------------------------------------------------

    ; Eax, Ebx, Edx are registers

  Mov WantContinue, 0   ; initialize WantContinue to zero

  .While ((WantContinue >= 0) && (WantContinue < -1))
  ; while WantContinue is greater or equal to 0 And
  ; WantContinue is less than -1 do
      Call Division
      Mov WantContinue, sval(input("Enter -1 to quit program : "))
      Invoke ClearScreen  ; clears the screen
  .EndW
     print chr$(13, 10)
  Ret
Main EndP
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;<<  Division procedure will calculate the quotient and remainder of a number  <<
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

Division Proc
	Local Dividend:DWord
	Local Divisor:DWord
	Local Quotient:DWord
	Local Remainder:DWord
	; Dividend is the number to be divided
	; Divisor is the number to divide the Dividend
	; Quotient is the integer division result by dividing the dividend number
	;   by the divisor number
	; Remainder is the integer result of the difference between
	;   dividend and the product of divisor and dividend in integer division
	
  	  print chr$(13, 10) ; a carriage return line feed will be
                         ; outputted to the screen
  	  print chr$("                  Quotient ", 13, 10)
  	  print chr$("         ", 218, "------------------------ ", 13, 10)
  	  print chr$(" Divisor |      Dividend ", 13, 10)
  	  print chr$("       --", 217, "  - (Divisor x Quotient) ", 13, 10)
  	  print chr$("           ---------------------- ", 13, 10)
  	  print chr$("                  Remainder      ", 13, 10)
  	  print chr$(13, 10, 13, 10) ; two carriage return line feeds will be
                                 ; outputted to the screen
  	  Mov Dividend, sval(input("Enter an integer value for Dividend : "))
  	  Mov Divisor, sval(input("Enter an integer value for Divisor : "))
  	 .If (Divisor != 0)    ; if Divisor not equal to zero
         print chr$(13, 10)
         print chr$(" Dividend = ")
         print str$(Dividend)
         print chr$(13, 10)
         print chr$(13, 10)
         print chr$(" Divisor = ")
         print str$(Divisor)
         print chr$(13, 10)
         print chr$(13, 10)

         Mov Eax, Dividend     ; set Eax = Dividend
         Mov Ebx, Divisor      ; set Ebx = Divisor
         Cdq                   ; convert to double quad word or 64-bit long word
         IDiv Ebx              ; Eax = Eax / Ebx
                               ; Eax = Dividend / Divisor
         Mov Quotient, Eax     ; set Quotient = Eax
         print chr$(" Quotient = ")
         print str$(Dividend)
         print chr$(" / ")
         print str$(Divisor)
         print chr$(13, 10)
         print chr$(" Quotient = ")
         print str$(Quotient)
         print chr$(13, 10)
         print chr$(13, 10)

         Mov Eax, Dividend    ; set Eax = Dividend
         Cdq                  ; convert to double quad word or 64-bit long word
         Mov Ebx, Divisor     ; set Ebx = Divisor
         IDiv Ebx             ; Eax = Eax / Ebx , Edx contains the remainder
                              ; Edx = [Dividend - (Divisor * Quotient)]
         Mov Remainder, Edx   ; set Remainder = Edx
         print chr$(" Remainder = ")
         print str$(Dividend)
         print chr$(" - ")
         print str$(Divisor)
         print chr$(" x ")
         print str$(Quotient)
         print chr$(13, 10)
         print chr$(" Remainder = ")
         print str$(Remainder)
         print chr$(13, 10)  
         print chr$(13, 10, 13, 10)  
     .ElseIf (Divisor == 0) ; if Divisor equals to zero
     	print chr$(13, 10)
     	print chr$("Can not divide! Division by zero!!", 13, 10)
     	print chr$(13, 10, 13, 10)
     .EndIf
	
	Ret
Division EndP
End start
